# -*- tcl -*-
# $Id: sandtool.tcl,v 1.31 2003/05/14 16:02:17 lioka Exp $
#
# Copyright (c) 2001,2002,2003 Sergey Bolshakov <sbolshakov@altlinux.ru>
# 
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

namespace eval tool {
    namespace import [namespace parent]::*
    namespace export init
    upvar [namespace parent]::layout layout
}

###############################################################################
# public 
#
proc tool::init {} {
    variable layout

    if {[catch {open [file join $layout(etcdir) sandd]} f]} {
	error "couldn't open required config file: $f"
    }

    parse $f opts
    close $f
    keylget opts global.fifo fifobase

    if {[catch {open $fifobase WRONLY} f]} {
	error $f
    }

    # FIXME insecure -- better way ?
    if {[info exists ::env(CVSROOT)] &&
	[set ndx [lsearch [set path [file split [pwd]]] cvs-serv*]] != -1} {
	set path [eval file join [lrange $path 0 $ndx]]
	chgrp cvs $path
	chmod g+rx $path
    }

    puts $f "[pid] -path [pwd] $::argv"
    close $f
    after 500 [list [namespace current]::connect $fifobase.[pid]]
    vwait [namespace current]::done
    if {![string eq [set [namespace current]::done] {}]} {
	puts [set [namespace current]::done]
	exit 1
    }
}

###############################################################################
# helpers
#
proc tool::connect {fname {count 0}} {
    if {[catch {open $fname RDONLY} fd]} {
	if {[incr count] > 100} {
	    puts stderr "no responce from server, exiting"
	    exit 1
	} else {
	    after 500 [list [namespace current]::connect $fname [incr count]]
	}
    } else {
	set [namespace current]::done [read $fd]
	close $fd
    }
}
